> You are reading the Docusign Developer Documentation. For clean Markdown of any page, append .md to the page URL.
>
> Documentation indexes by section:
> - APIs and SDKs: https://docusign.docs.buildwithfern.com/docs/llms.txt
> - Platform 101: https://docusign.docs.buildwithfern.com/platform/llms.txt
> - Extension Apps: https://docusign.docs.buildwithfern.com/extension-apps/llms.txt
> - Docusign CLI: https://docusign.docs.buildwithfern.com/docusign-cli/llms.txt
>
> Authentication (OAuth, JWT Grant, M2M): https://docusign.docs.buildwithfern.com/platform/auth
> Webhooks and Connect: https://docusign.docs.buildwithfern.com/platform/webhooks
>
> OpenAPI specifications: https://docusign.docs.buildwithfern.com/openapi.json
> MCP server: https://docusign.docs.buildwithfern.com/_mcp/server

# POST CMS

`POST /api/cms/v1/cms`

This method builds the CMS.

## Request Header Parameters

The following header parameters apply to the TSP API and the CMS API calls.

| Name                        | Type   | Description                                                                                                                     |
| --------------------------- | ------ | ------------------------------------------------------------------------------------------------------------------------------- |
| Authentication              | String | Required. See [Authentication](/docs/tsp-api/tsp101/tsp-authentication)                                                         |
| Content-Type                | String | Required. Specifies the type of data returned in the request body. This parameter must be set to `application/json`.            |
| X-Docusign-CorrelationToken | GUID   | Optional. ID used for telemetry. Docusign recommends that you set up a correlation token for all the TSP API and CMS API calls. |

## Request Body Parameters

This table provides descriptions of the information in the request body.

| Name                         | Description                                                                                                                                                                                                                                                                                                  |
| ---------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| signature                    | Required. The signature of the signed attributes hash in base64 format.                                                                                                                                                                                                                                      |
| signatureAlgorithmIdentifier | Required. The base64 encoding of the DER-encoded AlgorithmIdentifier. AlgorithmIdentifier is specified in [RFC 5280 §4.1.1.2](https://www.rfc-editor.org/info/rfc5280/#section-4.1.1.2) as: `AlgorithmIdentifier ::= SEQUENCE { algorithm OBJECT IDENTIFIER, parameters ANY DEFINED BY algorithm OPTIONAL }` |
| signedAttributes             | Required. The signed attributes.                                                                                                                                                                                                                                                                             |
| userCert                     | Required. Base 64 string of the user certificate.                                                                                                                                                                                                                                                            |
| hash                         | Required. The hash of the byte range returned by the Sign Hash Session Information request.                                                                                                                                                                                                                  |
| timestampToken               | Required. A timestamp token generated by a timestamping service.                                                                                                                                                                                                                                             |
| format                       | Required. At this time, the only valid value is "PADES".                                                                                                                                                                                                                                                     |

## Response information

If successful, this returns the CMS as a base 64 encoded string.

| Name | Description                                                                                                     |
| ---- | --------------------------------------------------------------------------------------------------------------- |
| cms  | Base 64 string representing the CMS, as specified by [RFC 5652](https://datatracker.ietf.org/doc/html/rfc5652). |

**`Request body layout`**

```json title="Request body layout"
{
  "signature": "base 64 string",
  "signedAttributes": "base 64 string",
  "userCert": "base 64 string",
  "hash": "base 64 string",
  "timestampToken": "base 64 string",
  "format": "string"
}
```

**`Response layout`**

```json title="Response layout"
{
  "cms": "base 64 string"
}
```